// ボタンBのクリックイベントリスナー
document.getElementById("autoSettingB").addEventListener("click", async function () {
    var selectedOptionB = document.getElementById("abilityOptionSelectB").value;
    await performCommonProcess(selectedOptionB, 'formData', 'B');
});

// ボタンLのクリックイベントリスナー
document.getElementById("autoSettingL").addEventListener("click", async function () {
    var selectedOptionL = document.getElementById("abilityOptionSelectL").value;
    await performCommonProcess(selectedOptionL, 'formData', 'L');
});

// ボタンRのクリックイベントリスナー
document.getElementById("autoSettingR").addEventListener("click", async function () {
    var selectedOptionR = document.getElementById("abilityOptionSelectR").value;
    await performCommonProcess(selectedOptionR, 'formData', 'R');
});

// ボタンAのクリックイベントリスナー
document.getElementById("autoSettingA").addEventListener("click", async function () {
    var selectedOptionR = document.getElementById("abilityOptionSelectA").value;
    await performCommonProcess(selectedOptionR, 'formData', 'A');
});


// 共通の処理
async function performCommonProcess(option, formDataKey, buttonType) {
    let settingId = 100;

    var url;
    if (buttonType == "A") {
        // 所持アビ一覧からリスト取得
        settingId = 101;
        const profile = await getProfile();
        const uid = profile[0].uid;
        let type = 1;
        let fb = 0;
        switch (option) {
            case 'frontA':
                type = 1;
                break;
            case 'frontS':
                type = 2;
                break;
            case 'frontR':
                type = 3;
            // 後衛
            case 'backA':
                fb = 1;
                type = 1;
                break;
            case 'backB':
                fb = 1;
                type = 2;
            case 'backY':
                fb = 1;
                type = 3;
                break;
            default:
                break;
        }
        // 前衛
        url = `https://g12010355.sp.pf.mbga.jp/?url=https%3A%2F%2Fmbga-sp.daisenran.jp%2Fuser%2Fuser_equip_ability_list.aspx%3Ftid%3D${uid}%26t%3D${fb}%26tt%3D${type}%26et%3D0%26rnd%3D559603&guid=ON`;

    }
    else {
        // 編成アビ
        var select2 = `abilityOptionSelect${buttonType}2`;
        var orderType = document.getElementById(select2).value;
        switch (option) {
            case 'frontA':
                url = `https://g12010355.sp.pf.mbga.jp/?url=https%3A%2F%2Fmbga-sp.daisenran.jp%2Fability%2Fequip_ability_sp.aspx%3Fpos%3D0%26at%3D1000%26s%3D${orderType}%26rnd%3D567663&guid=ON`;
                break;
            case 'frontS':
                url = `https://g12010355.sp.pf.mbga.jp/?url=https%3A%2F%2Fmbga-sp.daisenran.jp%2Fability%2Fequip_ability_sp.aspx%3Fpos%3D0%26at%3D100%26s%3D${orderType}%26rnd%3D142918&guid=ON`;
                break;

            case 'backA':
                url = `https://g12010355.sp.pf.mbga.jp/?url=https%3A%2F%2Fmbga-sp.daisenran.jp%2Fability%2Fequip_ability_sp.aspx%3Fpos%3D1%26at%3D1000%26s%3D${orderType}%26rnd%3D219800&guid=ON`;
                break;
            case 'backY':
                url = `https://g12010355.sp.pf.mbga.jp/?url=https%3A%2F%2Fmbga-sp.daisenran.jp%2Fability%2Fequip_ability_sp.aspx%3Fpos%3D1%26at%3D10%26s%3D${orderType}%26rnd%3D219800&guid=ON`;
                break;
            case 'backB':
                url = `https://g12010355.sp.pf.mbga.jp/?url=https%3A%2F%2Fmbga-sp.daisenran.jp%2Fability%2Fequip_ability_sp.aspx%3Fpos%3D1%26at%3D100%26s%3D${orderType}%26rnd%3D219800&guid=ON`;
                break;
            default:
                url = `https://g12010355.sp.pf.mbga.jp/?url=https%3A%2F%2Fmbga-sp.daisenran.jp%2Fability%2Fequip_ability_sp.aspx%3Fpos%3D0%26at%3D1000%26s%3D${orderType}%26rnd%3D567663&guid=ON`;
                break;
        }
    }
    console.log("form url:", url);

    try {
        const tab = await new Promise((resolve) => {
            chrome.tabs.create({ url: url }, (tab) => {
                resolve(tab);
            });
        });
        await chrome.storage.local.set({ [`settingId_${tab.id}`]: settingId });

        await new Promise((resolve) => {
            chrome.tabs.onUpdated.addListener(function listener(tabId, changeInfo) {
                if (tabId === tab.id && changeInfo.status === 'complete') {
                    chrome.tabs.onUpdated.removeListener(listener);
                    resolve();
                }
            });
        });
        await bsleep(1000); // データの取得が完了するまで待つ

        // 所持アビリスト
        const formData = await new Promise((resolve) => {
            chrome.storage.local.get([formDataKey], function (result) {
                if (chrome.runtime.lastError) {
                    console.error(chrome.runtime.lastError);
                    resolve(null);
                } else {
                    resolve(result[formDataKey]);
                }
            });
        });

        await bsleep(200);

        if (formData) {
            // 筆頭確認
            if (option == 'frontS' || option == 'backY') {
                const cardData = await getCardData();
                console.log("筆頭アビ取得", cardData);
                let abilities = '';
                for (let i = 0; i < cardData.length; i++) { // インデックスを0から始める
                    if (cardData[i].ctype == "軍師") {
                        abilities = cardData[i].abilities.split(',');
                        console.log("筆頭軍師:", abilities);
                        break;
                    }
                }
                if (abilities) {
                    for (let i = 0; i < formData.length; i++) { // インデックスを0から始める
                        const aname = formData[i].aname;
                        console.log(`${i} aname:`, aname);
                        if (abilities.includes(aname)) {
                            console.log("一致:", aname);
                            formData[i].fs = 1;
                            break;
                        }
                    }
                }
            }
            
            console.log('formData from local storage:', formData);
            await applyButtonData(formData, buttonType);
            displayMessage(`ボタンのデータを自動設定しました`, true);
        } else {
            displayMessage("データの読み込みに失敗しました", false);
        }


        // 奥義情報反映 
        if (buttonType == "A") {
            const ogiData = await new Promise((resolve) => {
                chrome.storage.local.get(['ogiData'], function (result) {
                    if (chrome.runtime.lastError) {
                        console.error(chrome.runtime.lastError);
                        resolve(null);
                    } else {
                        resolve(result['ogiData']);
                    }
                });
            });
            if (ogiData) {
                applyOgiButtonData(ogiData);
                console.log('ogiData from local storage:', ogiData);
            }
        }

    } catch (error) {
        displayMessage("エラーが発生しました", error);
    }
}


// tabから取得したデータをボタンに反映
async function applyButtonData(formData, buttonType) {
    console.log("applyButtonBData:", formData.length);
    var battleType = document.getElementById(`abilityOptionSelect${buttonType}3`).value;
    console.log("battleType", battleType);

    let aidArray = [];
    for (let i = 1; i <= formData.length; i++) {
        aidArray.push(formData[i - 1].aid);
    }
    const aidProperty = await getAbilityProperty(aidArray);
    console.log("aidProperty:", aidProperty);

    const abilityElements = document.querySelectorAll('textarea#b');
    console.log("abilityElements:", abilityElements)

    let bno = 1;
    for (let i = 1; i <= formData.length; i++) {
        let aid = formData[i - 1].aid;

        // 指定がボタンAで、B/L/Rに登録済みの場合はスキップ
        if (buttonType == "A" &&
            (await containsAid(aid, "buttonTextInputsB") ||
                await containsAid(aid, "buttonTextInputsL") ||
                await containsAid(aid, "buttonTextInputsR"))) {
            continue;
        }
        //console.log(`${i} bno=${bno} add: `, formData[i - 1].aname);

        const textElement = document.getElementById(`button${buttonType}${bno}Text`);
        const urlElement = document.getElementById(`button${buttonType}${bno}Url`);
        const propertyElement = document.getElementById(`button${buttonType}${bno}Property`);
        if (textElement && urlElement) {
            textElement.value = formData[i - 1].aname;
            urlElement.value = `http://sp.pf.mbga.jp/12010355/?guid=ON&url=https%3A%2F%2Fmbga-sp.daisenran.jp%2F${battleType}%2Fability_execute.ashx%3Faid%3D${aid}%26jid%3D4008001`;
            propertyElement.value = Number(aidProperty[i - 1].property);
            if (formData[i - 1].fs) {
                // 筆頭軍師アビ
                propertyElement.value = Number(propertyElement.value) + 64;
            }
            bno++;
        }
        //console.log("aid: ", formData[i - 1].aid);
    }
}


async function getAbilityProperty(aidlist) {
    console.log("aid:", aidlist);
    const url = `${BASE_URL}/rise/abi/property`;
    try {
        const response = await fetch(url, {
            method: 'POST',
            headers: {
                'Content-Type': 'text/csv',
            },
            body: aidlist.join(','),
        });

        if (!response.ok) {
            throw new Error(`Unexpected response status: ${response.status}`);
        }
        const csvData = await response.text();
        const parsedData = parseAbilityCsv(csvData);
        return parsedData;
    } catch (error) {
        console.error('Error during fetch:', error.message);
        return null;
    }
}


// CSVデータをパースする関数
function parseAbilityCsv(csvData) {
    const lines = csvData.split('\n');
    const headers = lines[0].split(',');
    const result = [];
    //console.log("lines:", lines);
    for (let i = 1; i < lines.length; i++) {
        const values = lines[i].split(',');
        if (values[0]) {
            const entry = {};
            for (let j = 0; j < headers.length; j++) {
                entry[headers[j]] = values[j];
            }
            console.log(`[${i}] enrty:`, entry);
            result.push(entry);
        }
    }

    return result;
}


// tabから取得したデータをボタンに反映 奥義用
async function applyOgiButtonData(ogiData) {
    console.log("applyButtonBData:", ogiData.length);
    const buttonType = "O";
    //var battleType = document.getElementById(`abilityOptionSelectA3`).value;

    let bno = 1;
    for (let i = 1; i <= ogiData.length; i++) {
        let aid = ogiData[i - 1].aid;
        let eid = ogiData[i - 1].eid;
        //let ggsg = ogiData[i - 1].ggsg;

        const buttonTextElement = document.getElementById(`button${buttonType}${bno}Text`);
        const buttonUrlElement = document.getElementById(`button${buttonType}${bno}Url`);
        const buttonGGSGElement = document.getElementById(`button${buttonType}${bno}GGSG`); // buttonO1GGSG
        //console.log(`button${buttonType}${bno}GGSG:`, buttonGGSGElement);
        if (buttonTextElement && buttonUrlElement) {
            buttonTextElement.value = ogiData[i - 1].aname;
            // https://g12010355.sp.pf.mbga.jp/?url=https%3A%2F%2Fmbga-sp.daisenran.jp%2Fbattle%2FOugiExecuter.ashx%3Faid%3D40628%26eid%3D1001431%26rnd%3D0&guid=ON
            buttonUrlElement.value = `https://g12010355.sp.pf.mbga.jp/?url=https%3A%2F%2Fmbga-sp.daisenran.jp%2Fbattle%2FOugiExecuter.ashx%3Faid%3D${aid}%26eid%3D${eid}%26rnd%3D0&guid=ON`;
            buttonGGSGElement.value = ogiData[i - 1].ggsg;
            bno++;
        }
    }

}


async function containsAid(aid, id) {
    const container = document.getElementById(id);
    const elements = container.querySelectorAll('textarea, input[type="text"]');

    return Array.from(elements).some((element) => {
        const textContent = element.value || element.textContent;
        if (textContent.includes(aid)) {
            //console.log('aid found!:', aid);
            return true;
        }
        return false;
    });
}


async function bsleep(waitMsec) {
    var startMsec = new Date();
    while (new Date() - startMsec < waitMsec) {
        await delay(1);
    }
}


async function delay(ms) {
    return new Promise(resolve => setTimeout(resolve, ms));
}
